﻿Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices

Public Class Form1

    ' Input- und OutputFile entsprechend anpassen!

    ' InputFile <- alle von der Media Foundation unterstützten Audio- und Video-Dateien
    Private Const InputFile As String = "d:\test.wav"

    ' muss MP3 sein ;-)
    Private Const OutputFile As String = "d:\converted.mp3"

    Private WithEvents Mp3Converter As ConvToMp3

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        Mp3Converter = New ConvToMp3

        Button1.Enabled = False

        If Mp3Converter.IsInitialized Then

            Button1.Enabled = True
            ProgressBarEx1.Minimum = 0
            ProgressBarEx1.Maximum = 100

        End If

    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing

        Mp3Converter.Dispose()

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        ProgressBarEx1.State = ProgressBarEx.ProgressBarState.NORMAL
        ProgressBarEx1.Value = 0

        ' Alternativ
        'Mp3Converter.InputFile = InputFile
        'Mp3Converter.OutputFile = OutputFile
        'If Mp3Converter.Convert Then

        'End If


        If Mp3Converter.Convert(InputFile, OutputFile) Then

            MessageBox.Show(Me, "Die Konvertierung war erfolgreich.", "ConvertToMp3",
                            MessageBoxButtons.OK, MessageBoxIcon.Information)

        Else

            MessageBox.Show(Me, "Ups, die Konvertierung war nicht erfolgreich.", "ConvertToMp3",
                            MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

    End Sub

    Private Sub Mp3Converter_Converted(Percent As Integer, [Error] As Boolean) Handles Mp3Converter.Converted

        If [Error] Then ProgressBarEx1.State = ProgressBarEx.ProgressBarState.ERROR

        ProgressBarEx1.Value = Percent

    End Sub

End Class

Public Class ProgressBarEx
    Inherits ProgressBar

    Private Const PBM_SETSTATE As Integer = &H410
    Private Const PBM_GETSTATE As Integer = &H411

    Public Enum ProgressBarState
        NORMAL = 1
        [ERROR] = 2
        PAUSED = 3
    End Enum

    <DllImport("User32.dll", EntryPoint:="SendMessageW")>
    Private Shared Function SendMessage(<[In]> hwnd As IntPtr,
                                        <[In]> Msg As Integer,
                                        <[In]> wParam As Integer,
                                        <[In]> lParam As IntPtr) As Integer
    End Function

    Public Property State As ProgressBarState
        Get
            Return CType(SendMessage(Me.Handle, PBM_GETSTATE, 0, IntPtr.Zero), ProgressBarState)
        End Get
        Set(value As ProgressBarState)
            SendMessage(Me.Handle, PBM_SETSTATE, value, IntPtr.Zero)
        End Set
    End Property

End Class
